package edu.kit.ipd.descartes.ql.connector.nop;

import org.apache.log4j.Logger;

import edu.kit.ipd.descartes.ql.connector.AbstractOSGiQueryConnector;
import edu.kit.ipd.descartes.ql.connector.util.DQLLogger;
import edu.kit.ipd.descartes.ql.models.mapping.domain.DomainFactory;
import edu.kit.ipd.descartes.ql.models.mapping.domain.Probe;
import edu.kit.ipd.descartes.ql.models.mapping.domain.Resource;
import edu.kit.ipd.descartes.ql.models.mapping.domain.Service;

public class AbstractNopQueryConnector extends AbstractOSGiQueryConnector {
	public final static Integer NUMBER_OF_ELEMENTS = 3;
	protected Logger log = DQLLogger.getLogger(this.getClass().getName());

	protected Probe createProbe(final DomainFactory domainFactory, final int number) {
		final Probe probe = domainFactory.createProbe();

		probe.setMetricName("metric" + number);
		log.debug("Appending probe " + probe.getMetricName());

		return probe;
	}

	protected Resource createResource(final DomainFactory domainFactory, final int number) {
		final Resource resource = domainFactory.createResource();

		resource.setIdentifier("res" + number);
		log.debug("Created resource " + resource.getIdentifier());

		return resource;
	}

	protected Service createService(final DomainFactory domainFactory, final int number) {
		final Service service = domainFactory.createService();

		service.setIdentifier("svc" + number);
		log.debug("Created service " + service.getIdentifier());

		return service;
	}
}
