package edu.kit.ipd.descartes.ql.connector;

/**
 * A StatefulQueryConnector is the extension of a QueryConnector, that retains
 * any information that are set prior to executing a query, e.g. constraints.
 * After query execution, all settings shall be reset.
 * 
 * This mechanism allows to implement caching mechanisms in the DQL Connector to
 * be implemented independently of the QEE layer.
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public interface StatefulQueryConnector extends QueryConnector {
	/**
	 * Resets all retained information
	 */
	public void reset();
}
