package edu.kit.ipd.descartes.ql.core.engine;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;

import com.google.inject.Guice;
import com.google.inject.Injector;

import edu.kit.ipd.descartes.ql.lang.DescartesQLRuntimeModule;

public class Activator implements BundleActivator {

	private static BundleContext context;

	private static Injector dqlInjector;

	public static BundleContext getContext() {
		return context;
	}

	public static Injector getDqlInjector() {
		return dqlInjector;
	}

	public static void setDqlInjector(final Injector dqlInjector) {
		Activator.dqlInjector = dqlInjector;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext
	 * )
	 */
	public void start(final BundleContext bundleContext) throws Exception {
		Activator.context = bundleContext;
		setDqlInjector(Guice.createInjector(new DescartesQLRuntimeModule()));
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(final BundleContext bundleContext) throws Exception {
		setDqlInjector(null);
		Activator.context = null;
	}

}
