package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

import org.apache.commons.math.stat.descriptive.DescriptiveStatistics;

public abstract class AbstractDescriptiveStatisticsAggregateCalculator implements AggregateCalculator {
	private final DescriptiveStatistics statistics = new DescriptiveStatistics();

	public void addValue(final BigDecimal value) {
		statistics.addValue(value.doubleValue());
	}

	protected DescriptiveStatistics getStatistics() {
		return statistics;
	}
}
