package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the geometric mean value
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class GeoMeanAggregateCalculator extends AbstractSummaryStatisticsAggregateCalculator {

	@Override
	public BigDecimal getResult() {
		if (!isValid()) {
			return BigDecimal.ZERO;
		}

		return new BigDecimal(getStatistics().getGeometricMean());
	}

	public boolean isValid() {
		return !Double.isNaN(getStatistics().getGeometricMean());
	}

}
