package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the maximum value
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class MaxAggregateCalculator implements AggregateCalculator {
	private BigDecimal currentMax;
	private boolean valid = false;

	public void addValue(final BigDecimal value) {
		// If not valid, initialize with first value for comparison
		if (!valid) {
			currentMax = value;
			valid = true;
		} else {
			if (value.compareTo(currentMax) == 1) {
				currentMax = value;
			}
		}
	}

	public BigDecimal getResult() {
		if (!valid) {
			return BigDecimal.ZERO;
		}

		return currentMax;
	}

	public boolean isValid() {
		return valid;
	}

}
