package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the mean value
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class MeanAggregateCalculator extends AbstractSummaryStatisticsAggregateCalculator {

	public BigDecimal getResult() {
		if (!isValid()) {
			return BigDecimal.ZERO;
		}

		return new BigDecimal(getStatistics().getMean());
	}

	public boolean isValid() {
		return !Double.isNaN(getStatistics().getMean());
	}

}
