package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the minimum value
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class MinAggregateCalculator implements AggregateCalculator {
	private BigDecimal currentMin;
	private boolean valid = false;

	public void addValue(final BigDecimal value) {
		// If not valid, initialize with first value for comparison
		if (!valid) {
			currentMin = value;
			valid = true;
		} else {
			if (value.compareTo(currentMin) == -1) {
				currentMin = value;
			}
		}
	}

	public BigDecimal getResult() {
		if (!valid) {
			return BigDecimal.ZERO;
		}

		return currentMin;
	}

	public boolean isValid() {
		return valid;
	}

}
