package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the sum
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class SumAggregateCalculator implements AggregateCalculator {
	private BigDecimal sum = new BigDecimal(0);

	public void addValue(final BigDecimal value) {
		sum = sum.add(value);
	}

	public BigDecimal getResult() {
		return sum;
	}

	public boolean isValid() {
		return true;
	}

}
