package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the sum of squares
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class SumOfSquaresAggregateCalculator implements AggregateCalculator {
	private BigDecimal sum = new BigDecimal(0);

	public void addValue(final BigDecimal value) {
		final BigDecimal pow = value.pow(2);
		sum = sum.add(pow);
	}

	public BigDecimal getResult() {
		return sum;
	}

	public boolean isValid() {
		return true;
	}

}
