package edu.kit.ipd.descartes.ql.core.engine.aggregates.calculators;

import java.math.BigDecimal;

/** 
 * Implementation of an AggregateController to compute the variance
 * 
 * @author Fabian Gorsler <fabian.gorsler@student.kit.edu>
 */
public class VarAggregateCalculator extends AbstractSummaryStatisticsAggregateCalculator {

	public BigDecimal getResult() {
		if (!isValid()) {
			return BigDecimal.ZERO;
		}

		return new BigDecimal(getStatistics().getVariance());
	}

	public boolean isValid() {
		return !Double.isNaN(getStatistics().getVariance());
	}

}
