package edu.kit.ipd.descartes.ql.core.engine.observations;

import edu.kit.ipd.descartes.ql.connector.PerformanceMetricsQueryConnector;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ConnectorTimeUnitClause;

public class ConnectorTimeUnitInterpreter implements ObservationInterpreter {
	private final ConnectorTimeUnitClause observation;

	public ConnectorTimeUnitInterpreter(final ConnectorTimeUnitClause observation) {
		this.observation = observation;
	}

	public void configureConnector(final PerformanceMetricsQueryConnector queryConnector, final long sampleSize) {
		final int amount = observation.getCount();
		final String unit = observation.getTimeIndicator();

		queryConnector.setObservationPeriod(amount, unit, sampleSize);
	}

	public void interpretDate() {
		// Nothing to do here
		return;
	}

}
