package edu.kit.ipd.descartes.ql.core.engine.observations;

import edu.kit.ipd.descartes.ql.lang.descartesQL.ConnectorInstanceReferenceClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ConnectorTimeUnitClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObservationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveBetweenClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveRelativeClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.SampleClause;

public class ObservationInterpreterFactory {

	public static ObservationInterpreter createInterpreter(final ObservationClause observation) {
		if (observation instanceof ConnectorTimeUnitClause) {
			return new ConnectorTimeUnitInterpreter((ConnectorTimeUnitClause) observation);
		}

		if (observation instanceof ObserveRelativeClause) {
			return new ObserveRelativeInterpreter((ObserveRelativeClause) observation);
		}

		if (observation instanceof ObserveBetweenClause) {
			return new ObserveBetweenInterpreter((ObserveBetweenClause) observation);
		}

		if (observation instanceof ConnectorInstanceReferenceClause) {
			return new ConnectorInstanceReferenceInterpreter((ConnectorInstanceReferenceClause) observation);
		}

		throw new IllegalArgumentException("Request for invalid ObservationClause: " + observation);
	}

	public static SampleInterpreter createInterpreter(final SampleClause sampleClause) {
		// TODO Auto-generated method stub
		return null;
	}

}
