package edu.kit.ipd.descartes.ql.core.engine.observations;

import static edu.kit.ipd.descartes.ql.core.engine.observations.TimeModifierConverter.convert;
import edu.kit.ipd.descartes.ql.lang.descartesQL.RelativeTimeDurationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.SampleClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.TimeModifierType;

public class SampleInterpreter {
	private long sampleSize = 0;

	public SampleInterpreter(final SampleClause sampleClause) {
		if (sampleClause != null) {
			interpretSample(sampleClause);
		}
	}

	public long getSampleSize() {
		return sampleSize;
	}

	private void interpretSample(final SampleClause sampleClause) {
		for (final RelativeTimeDurationClause r : sampleClause.getDurationClause()) {
			final int duration = r.getDuration();
			final TimeModifierType timeModifier = r.getTimeModifier();

			sampleSize += duration * convert(timeModifier);
		}
	}
}
