package edu.kit.ipd.descartes.ql.core.engine.util;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class AggregateHelper {

	public static void createOrUpdate(final Map<String, Set<String>> requiredMetrics, final String identifier,
			final String metricRef) {
		Set<String> set = requiredMetrics.get(identifier);

		if (set == null) {
			set = new HashSet<String>();
			requiredMetrics.put(identifier, set);
		}

		set.add(metricRef);
	}

	public static void mergeRequiredMetrics(final Map<String, Set<String>> requiredMetrics,
			final Map<String, Set<String>> additional) {
		if (additional == null) {
			return;
		}

		for (final String identifier : additional.keySet()) {
			final Set<String> additionalSet = additional.get(identifier);
			Set<String> set = requiredMetrics.get(identifier);

			if (set == null) {
				set = new HashSet<String>(additionalSet.size());
				requiredMetrics.put(identifier, set);
			}

			set.addAll(additionalSet);
		}
	}

}
