package edu.kit.ipd.descartes.ql.core.engine.util;

import static edu.kit.ipd.descartes.ql.core.engine.util.QueryParserHelper.intervalToProperties;
import static edu.kit.ipd.descartes.ql.core.engine.util.QueryParserHelper.toFlatConfigurationPropertiesClause;
import static edu.kit.ipd.descartes.ql.core.engine.util.QueryParserHelper.valueToProperties;

import java.util.Properties;

import org.eclipse.emf.ecore.EObject;

import edu.kit.ipd.descartes.ql.lang.descartesQL.ConfigurationPropertiesClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.DoFVariationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.IntervalVariationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ValueVariationClause;

public class DoFHelper {

	public static Properties processVariationClause(final EObject variationClause, Properties variationProperties) {
		if (variationClause instanceof ConfigurationPropertiesClause) {
			variationProperties = toFlatConfigurationPropertiesClause((ConfigurationPropertiesClause) variationClause);
		}

		if (variationClause instanceof DoFVariationClause) {
			final EObject variation = ((DoFVariationClause) variationClause).getVariation();

			if (variation instanceof IntervalVariationClause) {
				final IntervalVariationClause interval = (IntervalVariationClause) variation;
				variationProperties = intervalToProperties(interval);
			}

			if (variation instanceof ValueVariationClause) {
				final ValueVariationClause value = (ValueVariationClause) variation;
				variationProperties = valueToProperties(value);
			}
		}

		return variationProperties;
	}
}
