package edu.kit.ipd.descartes.ql.core.platform.eclipse.views;

import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.AGGREGATE;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.AGGREGATE_ICON_KEY;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.DOF;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.DOF_ICON_KEY;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.RESOURCE;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.RESOURCE_ICON_KEY;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.SERVICE;
import static edu.kit.ipd.descartes.ql.core.platform.eclipse.views.TableRowBean.SERVICE_ICON_KEY;

import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;

import edu.kit.ipd.descartes.ql.core.platform.eclipse.Activator;

class ViewLabelProvider extends LabelProvider implements ITableLabelProvider {

	private final ImageRegistry reg = Activator.getPlugin().getImageRegistry();

	@Override
	public Image getColumnImage(final Object obj, final int index) {
		if (index != 0) {
			return null;
		}

		final TableRowBean tableRow = (TableRowBean) obj;
		final String type = tableRow.getType();

		if (type.equals(SERVICE)) {
			return reg.get(SERVICE_ICON_KEY);
		} else if (type.equals(RESOURCE)) {
			return reg.get(RESOURCE_ICON_KEY);
		} else if (type.equals(AGGREGATE)) {
			return reg.get(AGGREGATE_ICON_KEY);
		} else if (type.equals(DOF)) {
			return reg.get(DOF_ICON_KEY);
		}

		return getImage(obj);
	}

	@Override
	public String getColumnText(final Object obj, final int index) {
		final TableRowBean row = (TableRowBean) obj;

		switch (index) {
		case TableRowBean.TYPE_POS:
			return row.getType();
		case TableRowBean.ALIAS_POS:
			return row.getAlias();
		case TableRowBean.IDENTIFIER_POS:
			return row.getIdentifier();
		case TableRowBean.METRIC_POS:
			return row.getMetricName();
		case TableRowBean.VALID_POS:
			return row.getValid();
		case TableRowBean.VALUE_POS:
			return row.getValue();
		case TableRowBean.ACCURACY_POS:
			return row.getAccuracy();
		}

		return "Unknown Column Index...";
	}

	@Override
	public Image getImage(final Object obj) {
		return PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_ELEMENT);
	}
}
