package edu.kit.ipd.descartes.ql.lang.examples.tests;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.junit.Assert.assertNull;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.junit.Test;

import edu.kit.ipd.descartes.ql.lang.descartesQL.DescartesQL;
import edu.kit.ipd.descartes.ql.lang.descartesQL.FilterClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.FilterConditionClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.FilterConjunction;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ListQuery;

public abstract class AbstractListQueryTest extends AbstractQueryTest implements ListQueryTestIface {
	public ListQuery getListQuery(final DescartesQL query) {
		final EObject queryRoot = query.getQuery();

		assertNotNull("Casting to ListQuery failed", queryRoot);

		return (ListQuery) (queryRoot);
	}

	@Test
	public final void testListQuery() {
		final EObject queryRoot = getQuery().getQuery();

		assertNotNull("Casting to ListQuery failed", queryRoot);
	}

	public void testNotNullFilterClause() {
		final ListQuery list = getListQuery(getQuery());
		final FilterClause filter = list.getFilterClause();
		assertNotNull(filter);

		final List<FilterConditionClause> filterConditions = filter.getFilterConditions();
		assertNotNull(filterConditions);
		assertEquals(1, filterConditions.size());

		final List<FilterConjunction> filterConjunctions = filter.getFilterConjunctions();
		assertNotNull(filterConjunctions);
		assertEquals(0, filterConjunctions.size());
	}

	public void testNullFilterClause() {
		final ListQuery list = getListQuery(getQuery());
		final FilterClause filter = list.getFilterClause();
		assertNull(filter);
	}

	@Override
	@Test
	public void testUsingClause() {
		testUsingClause(getListQuery(getQuery()).getUsingClause());
	}
}
