package edu.kit.ipd.descartes.ql.lang.examples.tests.list;

import static org.junit.Assert.assertEquals;

import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import edu.kit.ipd.descartes.ql.lang.DescartesQLInjectorProvider;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ListQuery;
import edu.kit.ipd.descartes.ql.lang.examples.tests.AbstractListQueryTest;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class ListEntitiesQuery extends AbstractListQueryTest {

	public static final String MODE = "ENTITIES";

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(LIST, this.getClass().getSimpleName()));
	}

	@Override
	@Test
	public void testFilterClause() {
		testNotNullFilterClause();
	}

	@Override
	@Test
	public void testListQueryMode() {
		final ListQuery list = getListQuery(getQuery());

		final edu.kit.ipd.descartes.ql.lang.descartesQL.ListEntitiesQuery listEntities = (edu.kit.ipd.descartes.ql.lang.descartesQL.ListEntitiesQuery) list
				.getQueryType();

		assertEquals("Mode not set correctly", MODE, listEntities.getMode());
	}

	@Override
	@Test
	public void testUsingClause() {
		testUsingClause(getListQuery(getQuery()).getUsingClause());
	}
}
