package edu.kit.ipd.descartes.ql.lang.examples.tests.select;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.List;

import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import edu.kit.ipd.descartes.ql.lang.DescartesQLInjectorProvider;
import edu.kit.ipd.descartes.ql.lang.descartesQL.AggregateMetricClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.EntityType;
import edu.kit.ipd.descartes.ql.lang.descartesQL.MetricClauseType;
import edu.kit.ipd.descartes.ql.lang.descartesQL.MetricReferenceClauses;
import edu.kit.ipd.descartes.ql.lang.examples.tests.AbstractSelectQueryTest;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class BasicQueryAggregate extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoF() {
		return false;
	}

	@Override
	public boolean expectObserve() {
		return false;
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testAggregate(final int i, final String aggregateFunction, final AggregateMetricClause aggregateType) {
		assertNotNull(aggregateFunction);
		assertNotNull(aggregateType);

		if (i == 0) {
			final AggregateMetricClause aggregate = aggregateType;
			assertNotNull(aggregate);
			assertEquals(aggregateFunction, aggregate.getFunction().getLiteral());

			final List<MetricClauseType> metrics = ((MetricReferenceClauses) aggregateType.getMetrics())
					.getMetricClauseTypes();

			assertNotNull(metrics);

			testMetricReferenceClause(metrics, new String[] { null, null, null, null, null, null, null, null },
					new String[] { "blade1", "blade2", "blade3", "blade4", "blade5", "blade6", "blade7", "blade8" },
					new String[] { "utilization", "utilization", "utilization", "utilization", "utilization",
							"utilization", "utilization", "utilization" });

			return;
		}
	}

	@Override
	public void testForClause() {
		testForClause(
				new EntityType[] { EntityType.RESOURCE, EntityType.RESOURCE, EntityType.RESOURCE, EntityType.RESOURCE,
						EntityType.RESOURCE, EntityType.RESOURCE, EntityType.RESOURCE, EntityType.RESOURCE },
				new String[] { "thisIsAnId1", "thisIsAnId2", "thisIsAnId3", "thisIsAnId4", "thisIsAnId5",
						"thisIsAnId6", "thisIsAnId7", "thisIsAnId8" }, new String[] { "blade1", "blade2", "blade3",
						"blade4", "blade5", "blade6", "blade7", "blade8" });
	}

	@Override
	public void testMetricReferenceClause() {
		testMetricReferenceClause(new String[] { "MAX" }, new String[] { null }, new String[] { null });
	}
}
