package edu.kit.ipd.descartes.ql.lang.examples.tests.select;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import edu.kit.ipd.descartes.ql.lang.DescartesQLInjectorProvider;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ConnectorTimeUnitClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.RelativeTimeDurationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.SampleClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.TimeModifierType;
import edu.kit.ipd.descartes.ql.lang.examples.tests.AbstractSelectQueryTest;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class BasicQueryObserve1 extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoF() {
		return false;
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testObserveClauseImpl(final ObserveClause observeClause) {
		final ConnectorTimeUnitClause observation = (ConnectorTimeUnitClause) observeClause.getObservation();
		assertNotNull(observation);
		assertEquals(100, observation.getCount());
		assertEquals("ModelInstances", observation.getTimeIndicator());

		final SampleClause sample = observeClause.getSampleClause();
		assertNotNull(sample);

		final EList<RelativeTimeDurationClause> duration = sample.getDurationClause();
		assertNotNull(duration);
		assertEquals(1, duration.size());

		final int[] durations = new int[] { 1 };
		final TimeModifierType[] modifiers = new TimeModifierType[] { TimeModifierType.HOUR };

		testRelativeTimeDuration(duration, durations, modifiers);
	}

}
