package edu.kit.ipd.descartes.ql.lang.examples.tests.select;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import edu.kit.ipd.descartes.ql.lang.DescartesQLInjectorProvider;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveRelativeClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ObserveRelativeDirectionType;
import edu.kit.ipd.descartes.ql.lang.descartesQL.RelativeTimeClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.RelativeTimeDurationClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.TimeModifierType;
import edu.kit.ipd.descartes.ql.lang.examples.tests.AbstractSelectQueryTest;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class BasicQueryObserve3 extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoF() {
		return false;
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testObserveClauseImpl(final ObserveClause observeClause) {
		final ObserveRelativeClause observation = (ObserveRelativeClause) observeClause.getObservation();
		assertNotNull(observation);

		final ObserveRelativeDirectionType direction = observation.getDirection();
		assertNotNull(direction);
		assertEquals(ObserveRelativeDirectionType.SINCE, direction);

		final RelativeTimeClause timeTarget = (RelativeTimeClause) observation.getTimeTarget();
		assertNotNull(timeTarget);

		final EList<RelativeTimeDurationClause> durationClause = timeTarget.getDurationClause();
		assertNotNull(durationClause);
		assertEquals(1, durationClause.size());

		testRelativeTimeDuration(durationClause, new int[] { 7 }, new TimeModifierType[] { TimeModifierType.DAY });
	}

}
