package edu.kit.ipd.descartes.ql.lang.examples.tests.select;

import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.runner.RunWith;

import edu.kit.ipd.descartes.ql.lang.DescartesQLInjectorProvider;
import edu.kit.ipd.descartes.ql.lang.descartesQL.ConfigurationPropertiesClause;
import edu.kit.ipd.descartes.ql.lang.descartesQL.VaryingClause;
import edu.kit.ipd.descartes.ql.lang.examples.tests.AbstractSelectQueryTest;

@RunWith(XtextRunner.class)
@InjectWith(DescartesQLInjectorProvider.class)
public class DoFQueryDynamicVariation extends AbstractSelectQueryTest {

	@Override
	public boolean expectConstraint() {
		return false;
	}

	@Override
	public boolean expectDoFConstraint() {
		return false;
	}

	@Override
	public boolean expectObserve() {
		return false;
	}

	@Override
	public boolean exploreDoFWith() {
		return false;
	}

	@Override
	public String getDoFConstraintName() {
		return super.getDoFConstraintName();
	}

	@Override
	public String getDoFExplorationStrategyName() {
		return "thisIsAnExplorationStrategyId";
	}

	@Override
	@Before
	public void initializeTest() throws Exception {
		super.initialize(createFileName(SELECT, this.getClass().getSimpleName()));
	}

	@Override
	public void testDoFGuidedByParameterClause(final ConfigurationPropertiesClause parameterClause) {
		testParameterClause(parameterClause, new String[] { "nop.first.property", "nop.another.property" },
				new String[] { "example", "here" });
	}

	@Override
	public void testDoFVaryingClause(final VaryingClause varyingClause) {
		testDoFVaryingClause(varyingClause, new String[] { "thisIsADoF1", "thisIsADoF2", "thisIsADoF3" }, new String[] {
				"res1_vcpus", "res1_memory", "res1_threads" });
	}
}
